---
title: XRInputSourceArray
slug: Web/API/XRInputSourceArray
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Interface
  - Mixed
  - Reality
  - Reference
  - Sources
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceArray
  - augmented
  - list
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">The interface <code><strong>XRInputSourceArray</strong></code> represents a <em>live</em> list of WebXR input sources, and is used as the return value of the {{domxref("XRSession")}} property {{domxref("XRSession.inputSources", "inputSources")}}.</span> Each entry is an {{domxref("XRInputSource")}} representing one input device connected to the WebXR system.</p>

<p>In addition to being able to access the input sources in the list using standard array notation (that is, with index numbers insize square brackets), methods are available to allow the use of iterators and the {{domxref("XRInputSourceArray.forEach", "forEach()")}} method is also available.</p>

<h2 id="Properties">Properties</h2>

<p><em>The following properties are available on <code>XRInputSourceArray</code> objects.</em></p>

<dl>
 <dt>{{domxref("XRInputSourceArray.length", "length")}} {{ReadOnlyInline}}</dt>
 <dd>The number of {{domxref("XRInputSource")}} objects in the list.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The following methods are available on <code>XRInputSourceArray</code> objects. You may also use the features of the <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Symbol">Symbol</a></code> type.</em></p>

<dl>
 <dt>{{domxref("XRInputSourceArray.entries", "entries()")}}</dt>
 <dd>Returns an <code><a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">iterator</a></code> you can use to walk the list of key/value pairs in the list. Each item returned is an array whose first value is the index and whose second value is the {{domxref("XRInputSource")}} at that index.</dd>
 <dt>{{domxref("XRInputSourceArray.forEach", "forEach()")}}</dt>
 <dd>Iterates over each item in the list, in order from first to last.</dd>
 <dt>{{domxref("XRInputSourceArray.keys", "keys()")}}</dt>
 <dd>A list of the keys corresponding to the entries in the input source list.</dd>
 <dt>{{domxref("XRInputSourceArray.values", "values()")}}</dt>
 <dd>Returns an <code>iterator</code> you can use to go through all the values in the list. Each item is a single {{domxref("XRInputSource")}} object.</dd>
</dl>

<p>In addition to these methods, you may use array notation to access items in the list by index For example, the snippet of code below calls a function <code>handleInput()</code>, passing into it the first item in the input source list, if the list isn't empty.</p>

<pre class="brush: js">let sources = xrSession.inputSources;
if (sources.length &gt; 0) {
  handleInput(sources[0]);
}
</pre>

<h2 id="Examples">Examples</h2>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#xrinputsourcearray-interface','XRInputSourceArray')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSourceArray")}}</p>
